#ifndef __SXPHYSMEM_H__
#define __SXPHYSMEM_H__

#include "sxTypes.h"

typedef enum {
	epmBelowOneMb		= (1),
	epmBelowSixteenMb	= (1 << 1),
} sx_physmem_flag_t;

#define SX_PHYS_PAGE_SIZE	4096
#define SX_PHYS_PAGE_ALIGN	SX_PHYS_PAGE_SIZE
#define SX_PHYS_MAX_PAGES	(1024 * 1024)

#define SX_PHYS_ALIGN(x, a) \
	(( ((sx_uint32)(x)) + (((sx_uint32)(a)) -1)) & (~(((sx_uint32)(a))-1)))

void SxPhysMemInit();
void SxPhysMemAddRegion(void*, sx_uint32);

void* SxPhysMemAlloc(sx_uint32, sx_physmem_flag_t);
void* SxPhysMemPlacementAlloc(void*, sx_uint32);
void SxPhysMemFree(void*, sx_uint32);

void SxPhysMemDumpState(sx_uint32 idx, sx_uint32 lines);
void SxPhysMemStat(sx_uint32*, sx_uint32*);



#endif